{-
	Copyright (C) 2012 Dr. Alistair Ward

	This program is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program.  If not, see <http://www.gnu.org/licenses/>.
-}
{- |
 [@AUTHOR@]	Dr. Alistair Ward

 [@DESCRIPTION@]	Calls the /quickChecks/-functions for modules supporting this feature.
-}

module ToolShed.Test.QuickChecks(
-- * Functions
	run
) where

import qualified	Control.Arrow
import qualified	ToolShed.Test.Data.Foldable
import qualified	ToolShed.Test.Data.List
import qualified	ToolShed.Test.Data.List.Runlength
import qualified	ToolShed.Test.Data.List.Splits
import qualified	ToolShed.Test.Data.Quadruple
import qualified	ToolShed.Test.Data.Triple
import qualified	ToolShed.Test.SelfValidate
import qualified	ToolShed.Test.System.Random

-- | Run the /quickChecks/-functions for modules supporting this feature.
run :: IO ()
run	= mapM_ (
	uncurry (>>) . Control.Arrow.first putStrLn
 ) [
	("Data.Foldable",	ToolShed.Test.Data.Foldable.quickChecks),
	("Data.List",		ToolShed.Test.Data.List.quickChecks),
	("Data.List.Runlength",	ToolShed.Test.Data.List.Runlength.quickChecks),
	("Data.List.Splits",	ToolShed.Test.Data.List.Splits.quickChecks),
	("Data.Quadruple",	ToolShed.Test.Data.Quadruple.quickChecks),
	("Data.Triple",		ToolShed.Test.Data.Triple.quickChecks),
	("SelfValidate",	ToolShed.Test.SelfValidate.quickChecks),
	("System.Random",	ToolShed.Test.System.Random.quickChecks)
 ]
